package com.szpg.rmi;

import org.apache.log4j.Logger;
import org.apache.struts2.ServletActionContext;

import com.opensymphony.xwork2.ActionSupport;
import com.szpg.db.dao.PgAcuDao;
import com.szpg.db.dao.PgAlarmRuleDao;
import com.szpg.db.dao.PgDeviceDao;
import com.szpg.db.dao.PgHjsbblDao;
import com.szpg.db.dao.impl.PgAcuDaoImpl;
import com.szpg.db.dao.impl.PgAlarmRuleDaoImpl;
import com.szpg.db.dao.impl.PgDeviceDaoImpl;
import com.szpg.db.dao.impl.PgHjsbblDaoImpl;
import com.szpg.db.data.PgAcu;
import com.szpg.db.data.PgHjsbbl;
import com.szpg.plc.message.AppMessageConstants;
import com.szpg.plc.message.command.ReadMemoryCommand;
import com.szpg.plc.message.command.WriteMemoryCommand;
import com.szpg.plc.protocol.fins.FINSConstants;
import com.szpg.plc.server.ACUClient;
import com.szpg.plc.server.ACUClientUtil;
import com.szpg.plc.util.ByteUtil;
import com.szpg.plc.util.Bytes;
import com.szpg.service.ReadSensorValueService;
import com.szpg.service.SetSensorThresholdService;
import com.szpg.util.Configure;
import com.szpg.util.NumberFormat;
import com.szpg.util.UnicodeConvertor;

import z.json.JSONObject;

public class RemoteCOCommandAction extends ActionSupport {

	/**
	 * 
	 */
	private static final long serialVersionUID = 2221187086461756012L;

	private String zcbh;
	
	private String threshold;
	
	private String format;
	private String jsoncallback;
	
	
	
	public String getZcbh() {
		return zcbh;
	}

	public void setZcbh(String zcbh) {
		this.zcbh = zcbh;
	}

	public String getThreshold() {
		return threshold;
	}

	public void setThreshold(String threshold) {
		this.threshold = threshold;
	}

	public String getFormat() {
		return format;
	}

	public void setFormat(String format) {
		this.format = format;
	}

	public String getJsoncallback() {
		return jsoncallback;
	}

	public void setJsoncallback(String jsoncallback) {
		this.jsoncallback = jsoncallback;
	}
	
	/**
	 * 读取一氧化碳实时监测值
	 * @return
	 * @throws Exception
	 */
	public String readCOValue() throws Exception {
		// 返回结果
		JSONObject jResult = new JSONObject();
		
		PgAcuDao acuDao = new PgAcuDaoImpl();
		
		if (null == zcbh || zcbh.equals("") == true) {
			jResult.put("success", false);
			jResult.put("code", "1");
			jResult.put("resaon", UnicodeConvertor.string2Unicode("资产编号为空"));
			
			returnToFront(jResult);
			return null;
		}
		
		String acucode = zcbh.substring(0, zcbh.indexOf(".", 6));
		PgAcu acu = acuDao.findACUByCode(acucode);
		if (null == acu) {
			jResult.put("success", false);
			jResult.put("code", "2");
			jResult.put("resaon", UnicodeConvertor.string2Unicode("未找到资产对应的PLC主机"));
			
			returnToFront(jResult);
			return null;
		}
		
		ACUClient client = ACUClientUtil.getInstance().getClients().get(acu.getAcu_host() + ":" + acu.getAcu_port());
		if (null != client) {
			ReadMemoryCommand command = ReadMemoryCommand.getInstance(AppMessageConstants.CMD_TYPE_READCOVALUE);
			String sour = Configure.getProperty("sys", "LOCALHOST.NET") + 
						  Configure.getProperty("sys", "LOCALHOST.NODE") + 
						  Configure.getProperty("sys", "LOCALHOST.UNIT");
			command.setMessageProducerId(sour);
			command.setMessageProducerHost(client.getHost());
			
			String dest = client.getNet() + client.getNode() + client.getUnit();
			
			command.setDestinationId(dest);
			
			command.setMemoryArea(FINSConstants.MEMORY_DM_AREA);
			
			try {
				// 设置读取的地址范围
				command.setStartAddress(ByteUtil.binToHexString(ByteUtil.intToBins(Integer.parseInt(Configure.getProperty("acubl", client.getAcucode() + ".CO.START")), 2)) + "00");
				command.setCountWord(Integer.parseInt(Configure.getProperty("acubl", client.getAcucode() + ".CO.WORDCOUNT")));
				
				// 调用服务过程执行命令发送服务
				ReadSensorValueService service = new ReadSensorValueService();
				service.executeService(client, (ReadMemoryCommand) command);
				Logger.getLogger(this.getClass().getName()).info(command);
			} catch (Exception ex) {
				Logger.getLogger(getClass().getName()).error("发送查询一氧化碳浓度指令异常" + ex);
			}
			
			jResult.put("success", true);
			jResult.put("resaon", UnicodeConvertor.string2Unicode("发送成功，请等待响应"));
			
			returnToFront(jResult);
			return null;
		} else {
			jResult.put("success", false);
			jResult.put("code", "3");
			jResult.put("resaon", UnicodeConvertor.string2Unicode("PLC主机不在线"));
			
			returnToFront(jResult);
			return null;
		}
	}
	
	/**
	 * 设置一氧化碳报警阈值
	 * @return
	 * @throws Exception
	 */
	public String setCOThreshold() throws Exception {
		// 返回结果
		JSONObject jResult = new JSONObject();
		
		PgAcuDao acuDao = new PgAcuDaoImpl();
		PgHjsbblDao blDao = new PgHjsbblDaoImpl();
		
		if (null == zcbh || zcbh.equals("") == true) {
			jResult.put("success", false);
			jResult.put("code", "1");
			jResult.put("resaon", UnicodeConvertor.string2Unicode("资产编号为空"));
			
			returnToFront(jResult);
			return null;
		}
		
		String acucode = zcbh.substring(0, zcbh.indexOf(".", 6));
		PgAcu acu = acuDao.findACUByCode(acucode);
		if (null == acu) {
			jResult.put("success", false);
			jResult.put("code", "2");
			jResult.put("resaon", UnicodeConvertor.string2Unicode("未找到资产对应的PLC主机"));
			
			returnToFront(jResult);
			return null;
		}
		
		ACUClient client = ACUClientUtil.getInstance().getClients().get(acu.getAcu_host() + ":" + acu.getAcu_port());
		if (null != client) {
			WriteMemoryCommand command = WriteMemoryCommand.getInstance(AppMessageConstants.CMD_TYPE_SETCOTHRESHOLD);
			
			// 源地址
			String sour = Configure.getProperty("sys", "LOCALHOST.NET") + 
						  Configure.getProperty("sys", "LOCALHOST.NODE") + 
						  Configure.getProperty("sys", "LOCALHOST.UNIT");
			
			// 目标地址
			String dest = client.getNet() + client.getNode() + client.getUnit();
			
			PgHjsbbl blObj = blDao.findBlByBh(zcbh + ".Set");
			if (null != blObj) {
				// SID在new对象的时候已经生成
				
				command.setMessageProducerId(sour);
				command.setMessageProducerHost(client.getHost());
				command.setDestinationId(dest);
				command.setMemoryArea(FINSConstants.MEMORY_WORK_AREA_WORD);
				
				int start = blObj.getKszdz();
				int end = blObj.getJszdz();
				
				// 开始字地址
				command.setStartAddress(ByteUtil.binToHexString(ByteUtil.intToBins(start, 2)) + "00");
				
				// 字数
				int n = end - start + 1;
				command.setCount(n);
				
				// 字内容
				byte[] temps = ByteUtil.intToBins(Float.floatToIntBits((float) NumberFormat.parseDouble(threshold, "0.00")));
				Bytes dataByte = new Bytes();
				for (int j = n; j > 0; j--) {
					dataByte.append(new byte[] {temps[2 * (j-1)], temps[2 * (j-1) + 1]});
				}
				command.setValue( dataByte.toBytes() );
				
				// 调用服务过程执行命令发送服务
				SetSensorThresholdService service = new SetSensorThresholdService();
				service.executeService(client, command);
				Logger.getLogger(this.getClass().getName()).info(command);
				
				jResult.put("success", true);
				jResult.put("resaon", UnicodeConvertor.string2Unicode("发送成功，请等待响应"));
				
				// 修改数据库中的报警阈值
				PgAlarmRuleDao ruleDao = new PgAlarmRuleDaoImpl();
				PgDeviceDao devDao = new PgDeviceDaoImpl();
				
				int deviceId = devDao.findDeviceIdByCode(zcbh);
				if (deviceId > 0) {
					try {
						// 更新阈值
						ruleDao.updateHighThresholdByDevice(deviceId, NumberFormat.parseDouble(threshold, "0.00"));
					} catch (Exception ex) {
						ex.printStackTrace();
					}
				}
				
				returnToFront(jResult);
				return null;
			} else {
				jResult.put("success", false);
				jResult.put("code", "4");
				jResult.put("resaon", UnicodeConvertor.string2Unicode("未找到对应变量"));
				
				returnToFront(jResult);
				return null;
			}
		} else {
			jResult.put("success", false);
			jResult.put("code", "3");
			jResult.put("resaon", UnicodeConvertor.string2Unicode("PLC主机不在线"));
			
			returnToFront(jResult);
			return null;
		}
	}
	
	
	/**
	 * 给前端返回
	 * @param jResult
	 * @throws Exception
	 */
	private void returnToFront(JSONObject jResult) throws Exception {
		// 返回jsonp格式的数据
		if (null != format && format.equalsIgnoreCase("jsonp") == true) {
			ServletActionContext.getResponse().getWriter().write(jsoncallback + "(" + jResult.toString() + ");");
		}

		ServletActionContext.getResponse().getWriter().write(jResult.toString());
	}
}
